<?php
/*
  $Id: quantumiframe.php 1813 2009-10-15 12:53:40Z hpdl $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2008 osCommerce

  Released under the GNU General Public License
  
  http://www.quantumgateway.com

  by

  Andres Roca - CDG Commerce
  andresr@cdgcommerce.com
*/

  class quantumiframe {
    var $code, $title, $description, $enabled;

// class constructor
    function quantumiframe() {
      global $order;

      $this->code = 'quantumiframe';
      $this->title = MODULE_PAYMENT_QUANTUMIFRAME_TEXT_TITLE;
      $this->public_title = MODULE_PAYMENT_QUANTUMIFRAME_TEXT_PUBLIC_TITLE;
      $this->description = MODULE_PAYMENT_QUANTUMIFRAME_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_QUANTUMIFRAME_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_QUANTUMIFRAME_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_QUANTUMIFRAME_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_QUANTUMIFRAME_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      $this->form_action_url = 'checkout_qgw_confirmation.php';
    }

// class methods
	
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_QUANTUMIFRAME_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_QUANTUMIFRAME_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->public_title . (strlen(MODULE_PAYMENT_QUANTUMIFRAME_TEXT_PUBLIC_DESCRIPTION) > 0 ? ' (' . MODULE_PAYMENT_QUANTUMIFRAME_TEXT_PUBLIC_DESCRIPTION . ')' : ''));
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $HTTP_POST_VARS, $currencies, $currency, $order, $languages_id;

      $process_button_string = tep_draw_hidden_field('Amount', number_format($order->info['total'], 2)) .
							   tep_draw_hidden_field('ID', tep_session_id());


	   $process_button_string .= tep_draw_hidden_field(tep_session_name(),tep_session_id());
      $lang_query = tep_db_query("select code from " . TABLE_LANGUAGES . " where languages_id = '" . (int)$languages_id . "'");
      $lang = tep_db_fetch_array($lang_query);

      switch (strtolower($lang['code'])) {
        case 'es':
          $process_button_string .= tep_draw_hidden_field('lang', 'sp');
          break;
      }

      return $process_button_string;
    }

    function before_process() {
      	global $messageStack, $insert_id, $_REQUEST;
		$id = $_REQUEST['ID'];
		$session_name = tep_session_name ();
	  
	  	$approved = (($_REQUEST['trans_result'] == "APPROVED") ? "1" : "0");
		if ($approved == "0") 
		{
			$comments = $_REQUEST['decline_reason'];
			// alert to customer:
			$payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($comments);
			//$messageStack->tep_session_register('checkout_payment', MODULE_PAYMENT_QUANTUMQGWDBE_TEXT_ERROR_MESSAGE, 'caution');
			tep_db_query("UPDATE " . TABLE_ORDERS_STATUS_HISTORY . " SET comments= 'Credit Card payment.  " . $comments . " " . $this->cc_card_type . " AUTH: " . $_REQUEST['authCode'] . ". TransID: " . $_REQUEST['transID'] . ".', date_added=now() WHERE orders_id = '" . (int)$insert_id . "'");
			tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
		
		}
	  
	  
    }

    function after_process() {
      return false;
    }

    function get_error() {
      global $_GET;
		$error = array('title' => MODULE_PAYMENT_QUANTUMIFRAME_TEXT_ERROR,
		'error' => stripslashes(urldecode($_GET['error'])));
		return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_QUANTUMIFRAME_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Quantum Gateway inline frame', 'MODULE_PAYMENT_QUANTUMIFRAME_STATUS', 'False', 'Do you want to accept Quantum Gateway payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API Username', 'MODULE_PAYMENT_QUANTUMIFRAME_APIUSERNAME', 'testing', 'API USERNAME', '6', '1', now())");
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API KEY', 'MODULE_PAYMENT_QUANTUMIFRAME_APIKEY', 'testing', 'API KEY', '6', '1', now())");
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('FRAME WIDTH IN PIXELS', 'MODULE_PAYMENT_QUANTUMIFRAME_WIDTH', '800', 'API KEY', '6', '1', now())");
	tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('FRAME HEIGHT IN PIXELS', 'MODULE_PAYMENT_QUANTUMIFRAME_HEIGHT', '600', 'API KEY', '6', '1', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_PAYMENT_QUANTUMIFRAME_SORT_ORDER', '0', 'Sort order of display (lowest is displayed first)', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_QUANTUMIFRAME_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_QUANTUMIFRAME_STATUS', 'MODULE_PAYMENT_QUANTUMIFRAME_APIUSERNAME', 'MODULE_PAYMENT_QUANTUMIFRAME_APIKEY', 'MODULE_PAYMENT_QUANTUMIFRAME_WIDTH', 'MODULE_PAYMENT_QUANTUMIFRAME_HEIGHT', 'MODULE_PAYMENT_QUANTUMIFRAME_ORDER_STATUS_ID', 'MODULE_PAYMENT_QUANTUMIFRAME_SORT_ORDER');
    }
  }
?>
